//------------------------------------------------------------------
//
//------------------------------------------------------------------
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  Aqua   // dots
#property indicator_color6  Gold
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  1
#property indicator_width6  1

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

//
//
//
//
//

extern int             TrixPeriod   = 14;
extern enPrices        TrixPrice    = pr_close; // Price to use 
extern int             SignalPeriod = 9;
extern ENUM_MA_METHOD  SignalMode   = 3;

//
//
//
//
//

double trixhu[];
double trixhd[];
double trixhbu[];
double trixhbd[];
double Up[];
double Dn[];
double trix[];
double sign[];
double diff[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(10);
   SetIndexBuffer(0,trixhu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,trixhd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trixhbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,trixhbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Up);      SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,167); 
   SetIndexBuffer(5,Dn);      SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,167); 
   SetIndexBuffer(6,trix);
   SetIndexBuffer(7,sign);
   SetIndexBuffer(8,diff);
   SetIndexBuffer(9,trend);
   IndicatorShortName("Trix ("+TrixPeriod+","+SignalPeriod+")");
   return(0);
}

//
//
//
//
//

double workTrix[][3];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(workTrix,0)!=Bars) ArrayResize(workTrix,Bars);

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+TrixPeriod);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = MathLog(getPrice(TrixPrice,Open,Close,High,Low,i));
            workTrix[r][0] =  workTrix[r-1][0]+alpha*(price         -workTrix[r-1][0]);
            workTrix[r][1] =  workTrix[r-1][1]+alpha*(workTrix[r][0]-workTrix[r-1][1]);
            workTrix[r][2] =  workTrix[r-1][2]+alpha*(workTrix[r][1]-workTrix[r-1][2]);
         
            if (workTrix[r-1][2]!=0)
                 trix[i] = (workTrix[r][2]-workTrix[r-1][2])/workTrix[r-1][2];
            else trix[i] = 0.00;
      }   
      for (i=limit; i>=0; i--)
      {
         sign[i]  = iMAOnArray(trix,0,SignalPeriod,0,SignalMode,i);
         diff[i]  = trix[i]-sign[i];
         trend[i] = trend[i+1];
            if (diff[i]>0) trend[i] =  1;
            if (diff[i]<0) trend[i] = -1;
            
            if (trend[i]== 1)
            {
               trixhu[i]  = High[i]; 
               trixhd[i]  = Low[i];
               trixhbu[i] = MathMax(Open[i],Close[i]);
               trixhbd[i] = MathMin(Open[i],Close[i]);
               Up[i]      = trixhd[i];
            }               
            if (trend[i]== -1)
            {
               trixhu[i]  = Low[i];
               trixhd[i]  = High[i];
               trixhbu[i] = MathMin(Open[i],Close[i]);
               trixhbd[i] = MathMax(Open[i],Close[i]);
               Dn[i]      = trixhd[i];
            } 
    }     
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}
